From ed878ec261a738a7a4fbc86fc89f7c1eb03b4df2 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:35:09 +0000
Subject: [PATCH 958/1001] Prepare the root view to use React only for the UI


---

diff --git a/hubs/tests/utils/test_views.py b/hubs/tests/utils/test_views.py
index 9c4f54f..13d9c1c 100644
--- a/hubs/tests/utils/test_views.py
+++ b/hubs/tests/utils/test_views.py
@@ -2,10 +2,10 @@ from __future__ import unicode_literals
 
 import flask
 
-import hubs.models
+from hubs.models import Hub, Widget
 from hubs.app import app
-from hubs.tests import APPTest, FakeAuthorization, auth_set, app_config
-from hubs.utils.views import get_visible_widgets, get_sse_url, move_widget
+from hubs.tests import APPTest, app_config
+from hubs.utils.views import get_sse_url, move_widget
 
 
 class ViewUtilsTest(APPTest):
@@ -19,74 +19,6 @@ class ViewUtilsTest(APPTest):
         self.app_context.__exit__(None, None, None)
         super(ViewUtilsTest, self).tearDown()
 
-    def test_removed_widget(self):
-        hub = hubs.models.Hub.get("ralph")
-        widget = hubs.models.Widget(
-            hub=hub, plugin="does-not-exist",
-            left=True, index=-1, _config="{}")
-        self.session.add(widget)
-        with auth_set(app, FakeAuthorization('ralph')):
-            widgets = get_visible_widgets(hub)
-        self.assertNotIn(
-            "does-not-exist", [w.plugin for w in widgets["left"]])
-        widget.left = False
-        self.assertNotIn(
-            "does-not-exist", [w.plugin for w in widgets["right"]])
-
-    def test_get_visible_widgets(self):
-        hub = hubs.models.Hub.get('ralph')
-        with auth_set(app, None):
-            widgets = get_visible_widgets(hub)
-        self.assertListEqual(
-            [w.plugin for w in widgets["left"]],
-            ["feed"])
-        self.assertListEqual(
-            [w.plugin for w in widgets["right"]],
-            ['contact', 'meetings', 'fedmsgstats', 'workflow.updates2stable',
-             'subscriptions', 'badges', 'pagure_pr', 'github_pr', 'bugzilla',
-             'halp', 'about']
-            )
-
-    def test_get_visible_widgets_preview(self):
-        hub = hubs.models.Hub.by_name('ralph')
-        hub.config.visibility = "preview"
-        meetings = hubs.models.Widget.query.filter_by(
-            hub=hub, plugin="meetings").first()
-        # make sure the test is valid
-        assert meetings.left is False
-        # set the widget to "restricted"
-        meetings.visibility = "restricted"
-        # Restricted widgets in preview hubs aren't displayed to
-        # anonymous users.
-        with auth_set(app, None):
-            widgets = get_visible_widgets(hub)
-        self.assertNotIn(
-            "meetings", [w.plugin for w in widgets["right"]])
-        # But they are displayed to members.
-        with auth_set(app, FakeAuthorization('ralph')):
-            widgets = get_visible_widgets(hub)
-        self.assertIn(
-            "meetings", [w.plugin for w in widgets["right"]])
-
-    def test_get_visible_widgets_private(self):
-        hub = hubs.models.Hub.by_name('ralph')
-        hub.config.visibility = "private"
-        meetings = hubs.models.Widget.query.filter_by(
-            hub=hub, plugin="meetings").first()
-        # make sure the test is valid
-        assert meetings.left is False
-        # Widgets in private hubs aren't displayed to
-        # anonymous users.
-        with auth_set(app, None):
-            widgets = get_visible_widgets(hub)
-        self.assertEqual(widgets["left"], [])
-        self.assertEqual(widgets["right"], [])
-        # But they are displayed to members.
-        with auth_set(app, FakeAuthorization('ralph')):
-            widgets = get_visible_widgets(hub)
-        self.assertNotEqual(len(widgets["left"]), 0)
-        self.assertNotEqual(len(widgets["right"]), 0)
-
     def test_sse_url(self):
         with app.test_request_context():
             self.assertEqual(get_sse_url(""), "http://localhost:8080/sse/")
@@ -131,18 +63,18 @@ class ViewUtilsTest(APPTest):
                     "http://example.com/hub/ralph")
 
     def test_move_widget(self):
-        hub = hubs.models.Hub(name="testing")
+        hub = Hub(name="testing")
         self.session.add(hub)
         widget_names = ["about", "badges", "bugzilla", "contact", "dummy"]
 
         def get_names():
             return [
                 w.plugin for w in
-                hubs.models.Widget.query.filter_by(hub=hub).order_by(hubs.models.Widget.index)
+                Widget.query.filter_by(hub=hub).order_by(Widget.index)
                 ]
 
         def get_widget(name):
-            return hubs.models.Widget.query.filter_by(hub=hub, plugin=name).one()
+            return Widget.query.filter_by(hub=hub, plugin=name).one()
 
         def check_move(name, position, expected):
             move_widget(get_widget(name), position)
@@ -151,7 +83,7 @@ class ViewUtilsTest(APPTest):
             self.assertListEqual(get_names(), expected)
 
         for index, name in enumerate(widget_names):
-            widget = hubs.models.Widget(
+            widget = Widget(
                 hub=hub, plugin=name,
                 left=True, index=index, _config="{}")
             self.session.add(widget)
diff --git a/hubs/tests/views/test_hub_view.py b/hubs/tests/views/test_hub_view.py
index 68b822c..be57081 100644
--- a/hubs/tests/views/test_hub_view.py
+++ b/hubs/tests/views/test_hub_view.py
@@ -1,91 +1,46 @@
 from __future__ import unicode_literals
 
-from flask import json
-
-from hubs.app import app
-from hubs.models import Hub
-from hubs.tests import APPTest, FakeAuthorization, auth_set
+from hubs.models import Hub, User
+from hubs.tests import APPTest, FakeAuthorization
 
 
 class HubViewTestCase(APPTest):
 
     def test_hub_logged_out(self):
-        with auth_set(app, None):  # check_auth doesn't load in unittest
-            result = self.app.get('/ralph', follow_redirects=True)
-            self.assertEqual(result.status_code, 200)
-            match_expected = r'<h5[^>]*>Ralph</h5>'
-            self.assertRegexpMatches(
-                result.get_data(as_text=True), match_expected)
-            str_expected = 'Not logged in.'
-            self.assertIn(str_expected, result.get_data(as_text=True))
+        response = self.check_url("/ralph/")
+        self.assertIn("Not logged in.", response.get_data(as_text=True))
+        self.assertEqual(response.context["page_title"], "ralph")
+        state = response.context["initial_state"]
+        self.assertEqual(state["urls"]["hubConfig"], "/api/hubs/ralph/config")
+        self.assertFalse(state["currentUser"]["logged_in"])
+        self.assertFalse(state["currentUser"]["can_config_hub"])
+        self.assertFalse(state["currentUser"]["can_manage_users"])
 
     def test_hub_logged_in(self):
         user = FakeAuthorization('ralph')
-        with auth_set(app, user):
-            result = self.app.get('/ralph', follow_redirects=True)
-            self.assertEqual(result.status_code, 200)
-            self.assertNotIn(
-                'Not logged in.  Click to <a href="/login">login</a>',
-                result.get_data(as_text=True))
+        response = self.check_url("/ralph/", user=user)
+        self.assertNotIn(
+            'Not logged in.  Click to <a href="/login">login</a>',
+            response.get_data(as_text=True))
+        state = response.context["initial_state"]
+        self.assertTrue(state["currentUser"]["logged_in"])
+        self.assertTrue(state["currentUser"]["can_config_hub"])
+        self.assertTrue(state["currentUser"]["can_manage_users"])
 
     def test_hub_preview(self):
         hub = Hub.by_name('ralph')
         hub.config.visibility = "preview"
         # Preview hubs are accessible to anonymous users (but some
         # widgets may be restricted).
-        with auth_set(app, None):
-            result = self.app.get('/ralph', follow_redirects=True)
-            self.assertEqual(result.status_code, 200)
+        self.check_url("/ralph/")
 
     def test_hub_private(self):
         hub = Hub.by_name('ralph')
         hub.config.visibility = "private"
         self.session.commit()
         # Private hubs are not accessible to anonymous users.
-        with auth_set(app, None):
-            result = self.app.get('/ralph', follow_redirects=True)
-            self.assertEqual(result.status_code, 403)
+        self.check_url("/ralph/", code=403)
         # But they are accessible to members.
-        user = FakeAuthorization('ralph')
-        with auth_set(app, user):
-            result = self.app.get('/ralph', follow_redirects=True)
-            self.assertEqual(result.status_code, 200)
-
-    def test_hub_json(self):
-        user = FakeAuthorization('ralph')
-        with auth_set(app, user):
-            result = self.app.get('/ralph/json', follow_redirects=True)
-        # assert the status code of the response
-        self.assertEqual(result.status_code, 200)
-        data = {
-            "config": {
-                "avatar": "https://seccdn.libravatar.org/avatar/"
-                          "9c9f7784935381befc302fe3c814f9136e7a339"
-                          "53d0318761669b8643f4df55c?s=312&d=retro",
-                'chat_channel': None,
-                'chat_domain': None,
-                "left_width": 8,
-                "summary": "Ralph",
-                "visibility": "public",
-            },
-            "members": ["ralph"],
-            "name": "ralph",
-            "owners": ["ralph"],
-            "subscribers": [],
-            "widgets": [34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 56],
-        }
-        self.assertDictEqual(data, json.loads(result.get_data(as_text=True)))
-
-    def test_hub_private_json(self):
-        hub = Hub.by_name('ralph')
-        hub.config.visibility = "private"
-        self.session.commit()
-        # Private hubs are not accessible to anonymous users.
-        with auth_set(app, None):
-            result = self.app.get('/ralph/json', follow_redirects=True)
-            self.assertEqual(result.status_code, 403)
-        # But they are accessible to members.
-        user = FakeAuthorization('ralph')
-        with auth_set(app, user):
-            result = self.app.get('/ralph/json', follow_redirects=True)
-            self.assertEqual(result.status_code, 200)
+        decause = User.by_username("decause")
+        hub.subscribe(decause, role='member')
+        self.check_url("/ralph/", user=FakeAuthorization("decause"))
diff --git a/hubs/utils/views.py b/hubs/utils/views.py
index 36df575..2445387 100644
--- a/hubs/utils/views.py
+++ b/hubs/utils/views.py
@@ -49,25 +49,34 @@ def get_widget_instance(hub, idx, session=None):
         flask.abort(404)
 
 
-def get_visible_widgets(hub):
-    from hubs.widgets import registry
-    widgets = {"left": [], "right": []}
-    try:
+def get_menu_entries():
+    """Get the entries for the left menu."""
+    menu = []
+    if flask.g.auth.logged_in:
         user = flask.g.user
-    except AttributeError:
-        user = None
-    for widget in hub.widgets:
-        if widget.plugin not in registry:
-            continue  # disabled widget
-        if not widget.allows(user, "view"):
-            continue
-        if widget.left:
-            widgets["left"].append(widget)
-        else:
-            widgets["right"].append(widget)
-    widgets["left"].sort(key=lambda w: w.index)
-    widgets["right"].sort(key=lambda w: w.index)
-    return widgets
+        menu.append({
+            "url": flask.url_for("hub", name=user.username),
+            "icon": "home",
+            "text": "My Hub",
+        })
+        menu.append({
+            "url": flask.url_for("stream"),
+            "icon": "home",
+            "text": "My Stream",
+        })
+        for hub in user.bookmarks:
+            menu.append({
+                "url": flask.url_for("hub", name=hub.name),
+                "icon": "bookmark",
+                "text": hub.name,
+                "cssClass": "idle-{}".format(hub.activity_class),
+            })
+    menu.append({
+        "url": flask.url_for("groups"),
+        "icon": "users",
+        "text": "All groups",
+    })
+    return menu
 
 
 class WidgetConfigError(Exception):
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 6677a7e..9dcd3d5 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -5,20 +5,49 @@ import hubs.models
 
 from hubs.app import app
 from hubs.utils.views import (
-    get_hub, get_sse_url, get_menu_entries, get_visible_widgets, require_hub_access,
+    get_hub, get_sse_url, get_menu_entries, require_hub_access,
     )
 
 
-@app.route('/<name>')
 @app.route('/<name>/')
 @require_hub_access("view")
 def hub(name):
     hub = get_hub(name, load_config=True)
-    widgets = get_visible_widgets(hub)
+    global_config = {
+        "chat_networks": app.config["CHAT_NETWORKS"],
+        "hub_visibility": hubs.models.HubConfig.VISIBILITY,
+        "roles": ["owner", "member"],
+    }
+    urls = {
+        "widgets": flask.url_for("api_hub_widgets", hub=hub.name),
+        "availableWidgets": flask.url_for("api_widgets"),
+        "sse": get_sse_url("hub/{}".format(hub.name)),
+        "hubConfig": flask.url_for("api_hub_config", name=hub.name),
+        "hubConfigSuggestUsers": flask.url_for(
+            "api_hub_config_suggest_users", name=hub.name),
+    }
+    current_user = flask.g.auth.copy()
+    current_user.update({
+        "can_view_hub": hub.allows(flask.g.user, "view"),
+        "can_config_hub": hub.allows(flask.g.user, "config"),
+        "can_manage_users": hub.allows(flask.g.user, "users.manage"),
+    })
+    menu = get_menu_entries()
+    flash_messages = [
+        {"msg": msg[1], "type": msg[0]} for msg in
+        flask.get_flashed_messages(with_categories=True)
+        ]
     return flask.render_template(
-        'hubs.html',
-        hub=hub,
-        widgets=widgets,
-        edit=False,
-        sse_url=get_sse_url("hub/{}".format(hub.name)),
+        'react.html',
+        page_title=hub.name,
+        initial_state=dict(
+            ui=dict(
+                page="Hub",
+                flashMessages=flash_messages,
+                leftMenu=menu,
+            ),
+            globalConfig=global_config,
+            urls=urls,
+            currentUser=current_user,
+            ),
         )

